package com.xxl.job.admin.core.thread;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.xxl.job.admin.core.complete.XxlJobCompleter;
import com.xxl.job.admin.core.conf.XxlJobAdminConfig;
import com.xxl.job.admin.core.model.XxlJobLog;
import com.xxl.job.core.biz.model.HandleCallbackParam;
import com.xxl.job.core.biz.model.ReturnT;
import java.util.Date;
import java.util.List;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.RejectedExecutionHandler;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JobCompleteHelper {
  private static Logger logger = LoggerFactory.getLogger(com.xxl.job.admin.core.thread.JobCompleteHelper.class);
  
  private static com.xxl.job.admin.core.thread.JobCompleteHelper instance = new com.xxl.job.admin.core.thread.JobCompleteHelper();
  
  public static com.xxl.job.admin.core.thread.JobCompleteHelper getInstance() {
    return instance;
  }
  
  private ThreadPoolExecutor callbackThreadPool = null;
  
  private Thread monitorThread;
  
  private volatile boolean toStop = false;
  
  public void start() {
    this.callbackThreadPool = new ThreadPoolExecutor(2, 20, 30L, TimeUnit.SECONDS, new LinkedBlockingQueue<>(3000), (ThreadFactory)new Object(this), (RejectedExecutionHandler)new Object(this));
    this.monitorThread = new Thread((Runnable)new Object(this));
    this.monitorThread.setDaemon(true);
    this.monitorThread.setName("xxl-job, admin JobLosedMonitorHelper");
    this.monitorThread.start();
  }
  
  public void toStop() {
    this.toStop = true;
    this.callbackThreadPool.shutdownNow();
    this.monitorThread.interrupt();
    try {
      this.monitorThread.join();
    } catch (Throwable e) {
      logger.error(e.getMessage(), e);
    } 
  }
  
  public ReturnT<String> callback(List<HandleCallbackParam> callbackParamList) {
    this.callbackThreadPool.execute((Runnable)new Object(this, callbackParamList));
    return ReturnT.SUCCESS;
  }
  
  private ReturnT<String> callback(HandleCallbackParam handleCallbackParam) {
    XxlJobLog log = XxlJobAdminConfig.getAdminConfig().getXxlJobLogDao().load(handleCallbackParam.getLogId());
    if (log == null)
      return new ReturnT(500, "log item not found."); 
    if (log.getHandleCode() > 0)
      return new ReturnT(500, "log repeate callback."); 
    StringBuffer handleMsg = new StringBuffer();
    if (log.getHandleMsg() != null)
      handleMsg.append(log.getHandleMsg()).append("<br>"); 
    if (handleCallbackParam.getHandleMsg() != null)
      handleMsg.append(handleCallbackParam.getHandleMsg()); 
    log.setHandleTime(new Date());
    log.setHandleCode(handleCallbackParam.getHandleCode());
    log.setHandleMsg(handleMsg.toString());
    XxlJobCompleter.updateHandleInfoAndFinish(log);
    return ReturnT.SUCCESS;
  }
}
